////////////////////////////////////////////////////////////////////////////////
//  
//  Copyright (C) 2012-2019 Eric Conte, Benjamin Fuks
//  The MadAnalysis development team, email: <ma5team@iphc.cnrs.fr>
//  
//  This file is part of MadAnalysis 5.
//  Official website: <https://launchpad.net/madanalysis5>
//  
//  MadAnalysis 5 is free software: you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation, either version 3 of the License, or
//  (at your option) any later version.
//  
//  MadAnalysis 5 is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
//  GNU General Public License for more details.
//  
//  You should have received a copy of the GNU General Public License
//  along with MadAnalysis 5. If not, see <http://www.gnu.org/licenses/>
//  
////////////////////////////////////////////////////////////////////////////////


// SampleAnalyzer headers
#include "SampleAnalyzer/Commons/Service/DisplayService.h"

using namespace MA5;

// Initializing the static member 
DisplayService* DisplayService::Service_ = 0;


void DisplayService::beginCoutRedirection(std::stringstream& str)
{ 
  oldCoutStreamBuf_ = std::cout.rdbuf();
  std::cout.rdbuf( str.rdbuf() );
}

void DisplayService::endCoutRedirection()
{
  std::cout.rdbuf( oldCoutStreamBuf_ ); 
  oldCoutStreamBuf_=0;
}

void DisplayService::beginCerrRedirection(std::stringstream& str)
{ 
  oldCerrStreamBuf_ = std::cerr.rdbuf();
  std::cerr.rdbuf( str.rdbuf() );
}

void DisplayService::endCerrRedirection()
{ 
  std::cerr.rdbuf( oldCerrStreamBuf_ ); 
  oldCerrStreamBuf_=0;
}
